> For the complete documentation index, see [llms.txt](https://docs.nosto.com/techdocs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/spa-faq.md).

# FAQ

## How do I track clicks on recommendations

This is done automatically by Nosto as long as you follow the [Handling attribution- topic](/techdocs/apis/frontend/implementation-guide-session-api/spa-basics-leveraging-features.md#handling-attribution-1).

Alternatively you can define the recommendation (`result_id`) after an [action](/techdocs/apis/frontend/implementation-guide-session-api/session-api-terminology.md#action) by adding `.setRef(productId, result_id)` to your call. In practice you would only do this when performing [the action for product view](/techdocs/apis/frontend/implementation-guide-session-api/spa-basics-tracking-events.md#upon-viewing-a-product).

Example when productId 123 was clicked on a recommendation *nosto-frontpage-1*:

```javascript
nostojs(api => {
    api
        .defaultSession()
        .viewProduct('123')
        .setRef('123', 'nosto-frontpage-1')
        .setPlacements(['nosto-page-product1'])
        .load()
        .then(data => {
            console.log(data);
        });
});
```

## Tracking external advertisement campaigns

Tracking external campaigns such as Google Ads, Facebook Ads, etc. will work automatically as long as you perform an [action](/techdocs/apis/frontend/implementation-guide-session-api/session-api-terminology.md#action) on the landing page of your ad.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/spa-faq.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
